UM Java API 6.17.1

- Main Page
- Related Pages
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
com.latencybusters.lbm.LBMSourceStatistics Class Reference
Inheritance diagram for com.latencybusters.lbm.LBMSourceStatistics:

## Public Member Functions
| LBMSourceStatistics ()
| LBMSourceStatistics (UMMonAttributes attributes, SourceTransport srcStats) throws LBMException
| LBMSourceStatistics (LBMMonitorReceiver lbmmonrcv, ByteBuffer attributeBuffer, ByteBuffer srcStats) throws LBMException
| LBMSourceStatistics (LBMContext lbmctx, int maxStats) throws LBMException
| LBMSourceStatistics (LBMSource lbmsrc) throws LBMException
| LBMSourceStatistics (LBMSSource lbmssrc) throws LBMException
void | refresh (LBMContext lbmctx, int maxStats) throws LBMException
void | refresh (LBMSource lbmsrc) throws LBMException
void | refresh (LBMSSource lbmssrc) throws LBMException
void | dispose ()
int | size ()
int | type () throws LBMException
int | type (int n) throws LBMException
String | typeName () throws LBMException
String | typeName (int n) throws LBMException
String | source () throws LBMException
String | source (int n) throws LBMException
long | numberOfClients () throws LBMException
long | numberOfClients (int n) throws LBMException
long | bytesBuffered () throws LBMException
long | bytesBuffered (int n) throws LBMException
long | messagesSent () throws LBMException
long | messagesSent (int n) throws LBMException
long | bytesSent () throws LBMException
long | bytesSent (int n) throws LBMException
long | transmissionWindowMessages () throws LBMException
long | transmissionWindowMessages (int n) throws LBMException
long | transmissionWindowBytes () throws LBMException
long | transmissionWindowBytes (int n) throws LBMException
long | nakPacketsReceived () throws LBMException
long | nakPacketsReceived (int n) throws LBMException
long | naksReceived () throws LBMException
long | naksReceived (int n) throws LBMException
long | naksIgnored () throws LBMException
long | naksIgnored (int n) throws LBMException
long | naksShed () throws LBMException
long | naksShed (int n) throws LBMException
long | naksIgnoredRetransmitDelay () throws LBMException
long | naksIgnoredRetransmitDelay (int n) throws LBMException
long | retransmissionsSent () throws LBMException
long | retransmissionsSent (int n) throws LBMException
long | retransmissionBytesSent () throws LBMException
long | retransmissionBytesSent (int n) throws LBMException
long | messagesQueued () throws LBMException
long | messagesQueued (int n) throws LBMException
long | retransmissionsQueued () throws LBMException
long | retransmissionsQueued (int n) throws LBMException
String | displayString (String aString)
String | getApplicationSourceId ()
InetAddress | getSender () throws UnknownHostException
Date | getTimestamp ()
long | getProcessId ()
long | getContextId ()
String | getContextInstance ()
long | getDomainId ()

## Protected Member Functions
void | finalize ()
String | getHexString (byte[] raw)
void | setSender (long ip)
void | setSenderIpv4Address (String ip) throws LBMException
void | setTimestamp (long ts)
void | setApplicationSourceId (String appid)
void | setProcessId (long pid)
void | setContextId (long cid)
void | setContextInstance (String cinst)
void | setDomainId (long did)

## Detailed Description

LBM Source Transport Statistics

This object provides user monitoring with access to statistics of an application being monitored. The user monitoring code can be part of the application being monitored (i.e. the application can be "self-monitoring"), or the monitoring code can be remote, using the lbmmon infrastructure to deliver statistics.

        Note that when stats are sampled, the fields in the structure are not
        necessarily from the same instant in time.  The structure might be
        updated concurrently with it being sampled, and while each structure
        field is atomically read, the field values can be skewed slightly
        across time.

## Constructor & Destructor Documentation

com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( |  | ) |

Instantiate an empty object containing no statistics.

Referenced by com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics().

com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( | UMMonAttributes | attributes,
|  | SourceTransport | srcStats
| ) |  | throws LBMException

Instantiate object containing the set of source transport statistics for a given source transport.

Parameters

  attributes | An UMMonAttributesProtos.UMMonAttributes
  srcStats | An UMSMonProtos.Stats.SourceTransport

Exceptions

  LBMException | if any error occurred retrieving source statistics.

References com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTIPC, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRU, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTSMX, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( | LBMMonitorReceiver | lbmmonrcv,
|  | ByteBuffer | attributeBuffer,
|  | ByteBuffer | srcStats
| ) |  | throws LBMException

Instantiate object containing the set of source transport statistics for a given source transport.

Parameters

  lbmmonrcv | LBMMonitorReceiver that received this packet.
  attributeBuffer | A ByteBuffer of packet attributes passed to the passthrough callback
  srcStats | A ByteBuffer of CSV statistics passed to the passthrough callback

Exceptions

  LBMException | if any error occurred retrieving source statistics.

References com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTIPC, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRU, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTSMX, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( | LBMContext | lbmctx,
|  | int | maxStats
| ) |  | throws LBMException

Instantiate object containing the current set of source transport statistics for a given LBM context This constructor will throw LBMMonitorEInvalException if maxStats is less than the available number of transport statistical sets.

Parameters

  lbmctx | LBMContext object associated with statistics to be retrieved
  maxStats | Maximum number of statistical sets to retrieve

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  refresh

References com.latencybusters.lbm.LBMSourceStatistics.refresh().

com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics | ( | LBMSource | lbmsrc | ) | throws LBMException

Instantiate object containing the current set of source transport statistics for a given LBM source.

Parameters

  lbmsrc | LBMSource object

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  refresh

References com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics(), and com.latencybusters.lbm.LBMSourceStatistics.refresh().

## Member Function Documentation

long com.latencybusters.lbm.LBMSourceStatistics.bytesBuffered | ( |  | ) | throws LBMException

Number of bytes currently in UM's TCP buffer, i.e., a snapshot (TCP only). This count is affected by the number of receivers,and configuration options transport_tcp_multiple_receiver_behavior and transport_session_maximum_buffer. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of bytes currently in UM's TCP buffer

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.bytesBuffered | ( | int | n | ) | throws LBMException

Number of bytes currently in UM's TCP buffer, i.e., a snapshot (TCP only). This count is affected by the number of receivers,and configuration options transport_tcp_multiple_receiver_behavior and transport_session_maximum_buffer. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of bytes currently in UM's TCP buffer

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.bytesSent | ( |  | ) | throws LBMException

Number of datagram bytes sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete message bytes sent (BROKER). This is the total of lengths of all transport packets, including UM header information (except BROKER). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of datagram bytes sent

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.bytesSent | ( | int | n | ) | throws LBMException

Number of datagram bytes sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete message bytes sent (BROKER). This is the total of lengths of all transport packets, including UM header information (except BROKER). This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of datagram bytes sent

Exceptions

  LBMException | if any error occurred retrieving source statistics.

void com.latencybusters.lbm.LBMSourceStatistics.dispose | ( |  | ) |

Free memory associated with this set of statistics.

Referenced by com.latencybusters.lbm.LBMObjectRecycler.close(), and com.latencybusters.lbm.LBMSourceStatistics.finalize().

void com.latencybusters.lbm.LBMSourceStatistics.finalize | ( |  | ) |
| protected

This method is for internal use only, and is not supported for customer applications.

References com.latencybusters.lbm.LBMSourceStatistics.dispose().

String com.latencybusters.lbm.LBMStatistics.getApplicationSourceId | ( |  | ) |
| inherited

Retrieve the application source identifier associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Application source ID

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

long com.latencybusters.lbm.LBMStatistics.getContextId | ( |  | ) |
| inherited

Retrieve the sending context ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Context ID

String com.latencybusters.lbm.LBMStatistics.getContextInstance | ( |  | ) |
| inherited

Retrieve the sending context instance associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Context Instance

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

long com.latencybusters.lbm.LBMStatistics.getDomainId | ( |  | ) |
| inherited

Retrieve the sending domain ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Domain ID

References com.latencybusters.lbm.LBMStatistics.getApplicationSourceId(), com.latencybusters.lbm.LBMStatistics.getContextInstance(), com.latencybusters.lbm.LBMStatistics.getSender(), and com.latencybusters.lbm.LBMStatistics.getTimestamp().

long com.latencybusters.lbm.LBMStatistics.getProcessId | ( |  | ) |
| inherited

Retrieve the sending process ID associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Process ID

InetAddress com.latencybusters.lbm.LBMStatistics.getSender | ( |  | ) | throws UnknownHostException
| inherited

Retrieve the IP sender address associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  InetAddress object corresponding to the statistics' sender IP address

Exceptions

  UnknownHostException | if IP address is of illegal length.

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

Date com.latencybusters.lbm.LBMStatistics.getTimestamp | ( |  | ) |
| inherited

Retrieve the timestamp associated with this set of statistics.

This attribute is only set for remote statistics returned by the lbmmon infrastructure. For locally-gathered statistics, this method returns an undefined value.

Returns
  Timestamp Date object

Referenced by com.latencybusters.lbm.LBMStatistics.getDomainId().

long com.latencybusters.lbm.LBMSourceStatistics.messagesQueued | ( |  | ) | throws LBMException

Number of datagrams currently queued by the data rate limiter (LBT-RM only). When a source transport attempts to send messages (any type) faster than its data rate limiter allows (set by configuration option transport_lbtrm_data_rate_limit, default 10Mbps), the data rate limiter queues the messages until they can be sent within the data rate limit. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of datagrams currently queued by the data rate limiter

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.messagesQueued | ( | int | n | ) | throws LBMException

Number of datagrams currently queued by the data rate limiter (LBT-RM only). When a source transport attempts to send messages (any type) faster than its data rate limiter allows (set by configuration option transport_lbtrm_data_rate_limit, default 10Mbps), the data rate limiter queues the messages until they can be sent within the data rate limit. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of datagrams currently queued by the data rate limiter

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.messagesSent | ( |  | ) | throws LBMException

Number of datagrams sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete messages sent (BROKER). Depending on batching settings, a single datagram may contain one or more messages, or a fragment of a larger message. With LBT-RM, larger messages are split into fragment sizes limited by configuration option transport_lbtrm_datagram_max_size (default 8KB). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of datagrams sent

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.messagesSent | ( | int | n | ) | throws LBMException

Number of datagrams sent (LBT-RM, LBT-RU, LBT-IPC, LBT-RDMA) or complete messages sent (BROKER). Depending on batching settings, a single datagram may contain one or more messages, or a fragment of a larger message. With LBT-RM, larger messages are split into fragment sizes limited by configuration option transport_lbtrm_datagram_max_size (default 8KB). This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of datagrams sent

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.nakPacketsReceived | ( |  | ) | throws LBMException

Number of NAK packets received by this source transport (LBT-RM, LBT-RU). UM batches NAKs into NAK packets to save network bandwidth. This should always be less than or equal to naksReceived (below). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of NAK packets received by this source transport

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.nakPacketsReceived | ( | int | n | ) | throws LBMException

Number of NAK packets received by this source transport (LBT-RM, LBT-RU). UM batches NAKs into NAK packets to save network bandwidth. This should always be less than or equal to naksReceived (below). This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of NAK packets received by this source transport

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnored | ( |  | ) | throws LBMException

Number of NAKs the source ignored and sent an NCF with reason code "ignored" (LBT-RM, LBT-RU). A source transport ignores a NAK for a datagram it has already recently retransmitted. How "recently" is determined by the configuration option source transport_lbtrm_ignore_interval (default 500ms). If this count is high, a receiver transport may be having trouble receiving retransmissions, or the ignore interval may be set too long. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of NAKs the source ignored and sent an NCF with reason code "ignored" code set to "ignored".

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnored | ( | int | n | ) | throws LBMException

Number of NAKs the source ignored and sent an NCF with reason code "ignored" (LBT-RM, LBT-RU). A source transport ignores a NAK for a datagram it has already recently retransmitted. How "recently" is determined by the configuration option source transport_lbtrm_ignore_interval (default 500ms). If this count is high, a receiver transport may be having trouble receiving retransmissions, or the ignore interval may be set too long. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of NAKs the source ignored and sent an NCF with reason code "ignored"

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnoredRetransmitDelay | ( |  | ) | throws LBMException

Number of NAKs this source did not process because doing so would exceed its retransmit rate limit (LBT-RM, LBT-RU). This rate limit is set by configuration option transport_lbtrm_retransmit_rate_limit (default 5Mbps). For each of these NAKs, the source transport immediately sends an NFC rx_delay, then queues the retransmission for a later send within the rate limit. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of NAKs ignored due to retransmit delay

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.naksIgnoredRetransmitDelay | ( | int | n | ) | throws LBMException

Number of NAKs this source did not process because doing so would exceed its retransmit rate limit (LBT-RM, LBT-RU). This rate limit is set by configuration option transport_lbtrm_retransmit_rate_limit (default 5Mbps). For each of these NAKs, the source transport immediately sends an NFC rx_delay, then queues the retransmission for a later send within the rate limit. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of NAKs ignored due to retransmit delay

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.naksReceived | ( |  | ) | throws LBMException

Number of individual NAKs received by the source transport (LBT-RM, LBT-RU). When a source transport receives a NAK from a receiver transport, it may respond by re-transmitting the requested LBT-RM datagram, or it may send an NCF. The NAKing receiver transport responds to the NCF by waiting (timeout set by transport_lbtrm_nak_suppress_interval, default 1000 ms), then re-sending the NAK. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of individual NAKs received by this source transport

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.naksReceived | ( | int | n | ) | throws LBMException

Number of individual NAKs received by the source transport (LBT-RM, LBT-RU). When a source transport receives a NAK from a receiver transport, it may respond by re-transmitting the requested LBT-RM datagram, or it may send an NCF. The NAKing receiver transport responds to the NCF by waiting (timeout set by transport_lbtrm_nak_suppress_interval, default 1000 ms), then re-sending the NAK. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of individual NAKs received by this source transport

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.naksShed | ( |  | ) | throws LBMException

Number of NAKs this source shed and sent an NCF with reason code "shed" (LBT-RM, LBT-RU). When a source transport's retransmit rate limiter and retransmit queue are both at maximum, it responds to a NAK by sending an "NCF shed", and does not retransmit. The receiver transport should wait, then send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of NAKs this source shed by sending an NCF with the reason code set to "shed"

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.naksShed | ( | int | n | ) | throws LBMException

Number of NAKs this source shed and sent an NCF with reason code "shed" (LBT-RM, LBT-RU). When a source transport's retransmit rate limiter and retransmit queue are both at maximum, it responds to a NAK by sending an "NCF shed", and does not retransmit. The receiver transport should wait, then send another NAK. If this count is high, one or more crybaby receiver transports may be clogging the source transport's retransmit queue. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of NAKs this source shed by sending an NCF with the reason code set to "shed"

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.numberOfClients | ( |  | ) | throws LBMException

Number of receiver clients currently connected over this transport (TCP, LBT-RU, LBT-IPC, LBT-RDMA). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of receiver clients currently connected over this transport

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.numberOfClients | ( | int | n | ) | throws LBMException

Number of receiver clients currently connected over this transport (TCP, LBT-RU, LBT-IPC, LBT-RDMA). This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of receiver clients currently connected over this transport

Exceptions

  LBMException | if any error occurred retrieving source statistics.

void com.latencybusters.lbm.LBMSourceStatistics.refresh | ( | LBMContext | lbmctx,
|  | int | maxStats
| ) |  | throws LBMException

Refresh source transport statistics for a given LBM context. This method will throw LBMMonitorEInvalException if maxStats is less than the available number of transport statistical sets.

Parameters

  lbmctx | LBMContext object associated with statistics to be retrieved
  maxStats | Maximum number of statistical sets to retrieve

Exceptions

  LBMException | if any error occurred retrieving source statistics.

Referenced by com.latencybusters.lbm.LBMContext.getSourceStatistics(), com.latencybusters.lbm.LBMSSource.getStatistics(), com.latencybusters.lbm.LBMSource.getStatistics(), com.latencybusters.lbm.LBMSourceStatistics.LBMSourceStatistics(), and com.latencybusters.lbm.LBMSourceStatistics.refresh().

void com.latencybusters.lbm.LBMSourceStatistics.refresh | ( | LBMSource | lbmsrc | ) | throws LBMException

Refresh source transport statistics for a given LBM source

Parameters

  lbmsrc | LBMSource object

Exceptions

  LBMException | if any error occurred retrieving source statistics.

References com.latencybusters.lbm.LBMSourceStatistics.refresh().

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionBytesSent | ( |  | ) | throws LBMException

Number of bytes retransmitted by this source transport (LBT-RM, LBT-RU). This count is triggered under the same circumstances as retransmissionsSent, above. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKs received (naksReceived). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of transport bytes retransmitted by this source

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionBytesSent | ( | int | n | ) | throws LBMException

Number of bytes retransmitted by this source transport (LBT-RM, LBT-RU). This count is triggered under the same circumstances as retransmissionsSent, above. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKs received (naksReceived). This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of transport bytes retransmitted by this source

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued | ( |  | ) | throws LBMException

Number of retransmission datagrams currently queued by the retransmit rate limiter (LBT-RM only). When a source transport attempts to send retransmissions faster that its retransmit rate limiter allows (set by configuration option transport_lbtrm_retransmit_rate_limit, default 5Mbps), the retransmit rate limiter queues retransmissions until they can be sent within the rate limit. naks_rx_delay_ignored (above) will generally also rise if this count is high This method returns a value from the first This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of datagrams currently queued by the retransmit rate limiter

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued | ( | int | n | ) | throws LBMException

Number of retransmission datagrams currently queued by the retransmit rate limiter (LBT-RM only). When a source transport attempts to send retransmissions faster that its retransmit rate limiter allows (set by configuration option transport_lbtrm_retransmit_rate_limit, default 5Mbps), the retransmit rate limiter queues retransmissions until they can be sent within the rate limit. naks_rx_delay_ignored (above) will generally also rise if this count is high This method returns a value from the first This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of datagrams currently queued by the retransmit rate limiter

Exceptions

  LBMException | if any error occurred retrieving source statistics.

References com.latencybusters.lbm.LBMSourceStatistics.bytesBuffered(), com.latencybusters.lbm.LBMSourceStatistics.bytesSent(), com.latencybusters.lbm.LBMSourceStatistics.messagesQueued(), com.latencybusters.lbm.LBMSourceStatistics.messagesSent(), com.latencybusters.lbm.LBMSourceStatistics.nakPacketsReceived(), com.latencybusters.lbm.LBMSourceStatistics.naksIgnored(), com.latencybusters.lbm.LBMSourceStatistics.naksIgnoredRetransmitDelay(), com.latencybusters.lbm.LBMSourceStatistics.naksReceived(), com.latencybusters.lbm.LBMSourceStatistics.naksShed(), com.latencybusters.lbm.LBMSourceStatistics.numberOfClients(), com.latencybusters.lbm.LBMSourceStatistics.retransmissionBytesSent(), com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued(), com.latencybusters.lbm.LBMSourceStatistics.retransmissionsSent(), com.latencybusters.lbm.LBMSourceStatistics.source(), com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowBytes(), com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowMessages(), com.latencybusters.lbm.LBM.TRANSPORT_STAT_BROKER, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTIPC, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRDMA, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRU, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTSMX, com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP, com.latencybusters.lbm.LBMSourceStatistics.type(), and com.latencybusters.lbm.LBMSourceStatistics.typeName().

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsSent | ( |  | ) | throws LBMException

Number of datagrams retransmitted by this source transport (LBT-RM, LBT-RU). This count is incremented under the same circumstances as retransmissionBytesSent, below. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKS received (naksReceived). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of datagrams retransmitted by this source

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.retransmissionsSent | ( | int | n | ) | throws LBMException

Number of datagrams retransmitted by this source transport (LBT-RM, LBT-RU). This count is incremented under the same circumstances as retransmissionBytesSent, below. In a normal, light-loss scenario, most NAKs received induce a retransmission. When losses become heavy and/or many receiver transports begin losing the same datagrams, NCF-related no-retransmit counts (naksIgnored, naksShed and naksIgnoredRetransmitDelay) may begin to inflate, and retransmissions retransmissionsSent) may become significantly lower than NAKS received (naksReceived). This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of datagrams retransmitted by this source

Exceptions

  LBMException | if any error occurred retrieving source statistics.

int com.latencybusters.lbm.LBMSourceStatistics.size | ( |  | ) |

Number of statistical sets encapsulated within this object

Returns
  Statistical set size

String com.latencybusters.lbm.LBMSourceStatistics.source | ( |  | ) | throws LBMException

Source of a transport as a string. The string format depends on transport type and is described under LBMTransportSourceInfo. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

See also
  LBMTransportSourceInfo

Returns
  Source of transport as a string

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued(), and com.latencybusters.lbm.LBMSourceStatistics.source().

String com.latencybusters.lbm.LBMSourceStatistics.source | ( | int | n | ) | throws LBMException

Source of a transport as a string. The string format depends on transport type and is described under LBMTransportSourceInfo. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

See also
  LBMTransportSourceInfo

Returns
  Source of transport as a string

Exceptions

  LBMException | if any error occurred retrieving source statistics.

References com.latencybusters.lbm.LBMSourceStatistics.source().

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowBytes | ( |  | ) | throws LBMException

Number of bytes currently in the transmission window (LBT-RM only). Typically, this count approaches its window size or exceeds it by a small amount. See transmissionWindowMessages for a description of the transmission window. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of bytes currently in the transmission window

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowBytes | ( | int | n | ) | throws LBMException

Number of bytes currently in the transmission window (LBT-RM only). Typically, this count approaches its window size or exceeds it by a small amount. See transmissionWindowMessages for a description of the transmission window. This method returns a value from the nth set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of bytes currently in the transmission window

Exceptions

  LBMException | if any error occurred retrieving source statistics.

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowMessages | ( |  | ) | throws LBMException

Number of datagrams in the transmission window (LBT-RM only). Each source transport session maintains a transmission window buffer (the size of which is set by transport_lbtrm_transmission_window_size, default 24MB). When the source transport receives a NAK, the corresponding message for retransmission must be found in this transmission window. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Number of datagrams in the transmission window

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

long com.latencybusters.lbm.LBMSourceStatistics.transmissionWindowMessages | ( | int | n | ) | throws LBMException

Number of datagrams in the transmission window (LBT-RM only). Each source transport session maintains a transmission window buffer (the size of which is set by transport_lbtrm_transmission_window_size, default 24MB). When the source transport receives a NAK, the corresponding message for retransmission must be found in this transmission window. This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Parameters

  n | Statistics set index

Returns
  Number of datagrams in the transmission window

Exceptions

  LBMException | if any error occurred retrieving source statistics.

int com.latencybusters.lbm.LBMSourceStatistics.type | ( |  | ) | throws LBMException

Transport type (TCP, LBT-RM, LBT-RU, etc.). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Transport type

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)
  LBM

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued(), and com.latencybusters.lbm.LBMSourceStatistics.type().

int com.latencybusters.lbm.LBMSourceStatistics.type | ( | int | n | ) | throws LBMException

Transport type (TCP, LBT-RM, LBT-RU, etc.). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Transport type

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBM

References com.latencybusters.lbm.LBMSourceStatistics.type().

String com.latencybusters.lbm.LBMSourceStatistics.typeName | ( |  | ) | throws LBMException

Transport type name (TCP, LBT-RM, LBT-RU, etc.). This method returns a value from the first set of statistics encapsulated within this object and would normally be used when the object has been created using a specific source to instantiate the class.

Returns
  Transport type name

Exceptions

  LBMException | if any error occurred retrieving source statistics.

See also
  LBMSourceStatistics(LBMSource)

Referenced by com.latencybusters.lbm.LBMSourceStatistics.retransmissionsQueued().

String com.latencybusters.lbm.LBMSourceStatistics.typeName | ( | int | n | ) | throws LBMException

Transport type name (TCP, LBT-RM, LBT-RU, etc.). This method returns a value from the nth set of statistics encapsulated within this object.

Parameters

  n | Statistics set index

Returns
  Transport type name

Exceptions

  LBMException | if any error occurred retrieving source statistics.

References com.latencybusters.lbm.LBM.TRANSPORT_STAT_BROKER, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTIPC, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRDMA, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRM, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTRU, com.latencybusters.lbm.LBM.TRANSPORT_STAT_LBTSMX, and com.latencybusters.lbm.LBM.TRANSPORT_STAT_TCP.

The documentation for this class was generated from the following file:

- LBMSourceStatistics.java